%global momorel 9

%global dbver      20060505
%global enginever  3.0-20060505
%global filtersver 3.0-20060505
%global hpijsver   1.5-20060505

%global with_omni 0

Summary: Foomatic printer database.
Name: foomatic
Version: 3.0.2
Release: %{momorel}m%{?dist}
Group: System Environment/Libraries
License: GPL
URL: http://www.linuxprinting.org/

# Generated by:
# NOW=`date '+%Y%m%d'`
# cvs -d:pserver:anonymous@cvs.linuxprinting.org:/usr/local/cvs export -D $NOW foomatic
# tar cjf foomatic-1.9-$NOW.tar.bz2 foomatic
Source0: http://www.linuxprinting.org/download/foomatic/%{name}-db-engine-%{enginever}.tar.gz
Source1: http://www.linuxprinting.org/download/foomatic/%{name}-filters-%{filtersver}.tar.gz
Source2: http://www.linuxprinting.org/download/foomatic/foomatic-db-3.0-%{dbver}.tar.gz
Source3: http://www.linuxprinting.org/download/foomatic/foomatic-db-hpijs-%{hpijsver}.tar.gz

%if %{with_omni}
# Build Omni first to get this (you'll have to create the tarball by hand):
Source4: Omni-printers-0.9.2.tar.bz2
%endif

# The foomatic-db info from gimp-print (--with-ijs --with-foomatic)
Source5: gimp-print-foomatic-db-4.2.7.tar.bz2

# Use libdir.
Patch1: foomatic-filters-libdir.patch
Patch2: foomatic-db-engine-libdir.patch

# Set GS_FONTPATH in gs wrapper (bug #81410).
Patch5: foomatic-2.0.2-fontpath.patch

# Reinstate ppdload long enough for me to work around its disappearance.
Patch6: foomatic-ppdload.patch
Patch7: foomatic-ppdload-ppd.patch

# Don't break gimp-print driver
Patch9: foomatic-printoutmode.patch

# Fix 3.0.2 build.
Patch10: foomatic-db-engine-xml-cflags.patch

# Make foomatic-db-engine build.
Patch14: foomatic-ampathxml.patch

# Handle non-UTF-8 encodings in imported PPD files.
Patch15: foomatic-bad-utf8.patch

Patch20:foomatic-filters-3.0-20060505-lib64.patch
Patch21:foomatic-db-engine-3.0-20060505-lib64.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: perl >= 5.8.2
BuildRequires: libxml2-devel
BuildRequires: a2ps
BuildRequires: cups
Provides:      perl(Foomatic::GrovePath)
PreReq: coreutils, initscripts
Obsoletes: Omni, Omni-foomatic, foomatic-db
Conflicts: ghostscript < 7.05
Conflicts: system-config-printer < 0.6.147

%description
Foomatic is a comprehensive, spooler-independent database of printers,
printer drivers, and driver descriptions. It contains utilities to
generate driver description files and printer queues for CUPS, LPD,
LPRng, and PDQ using the database. There is also the possibility to
read the PJL options out of PJL-capable laser printers and take them
into account at the driver description file generation.

There are spooler-independent command line interfaces to manipulate
queues (foomatic-configure) and to print files/manipulate jobs
(foomatic printjob).

The site http://www.linuxprinting.org/ is based in this database.

%prep
%setup -q -c -a 1 -a 2 -a 3

pushd foomatic-filters-%{filtersver}
# %patch1 -p1 -b .libdir
%patch5 -p1 -b .fontpath
%if %{_lib} == "lib64"
%patch20 -p1 -b .lib64
%endif

./make_configure
popd

pushd foomatic-db-engine-%{enginever}
chmod a+x mkinstalldirs
# %patch2 -p1 -b .libdir
# %patch6 -p1 -b .ppdload
%patch14 -p1 -b .ampathxml
%patch10 -p1 -b .xml-cflags
%patch15 -p1
%if %{_lib} == "lib64"
%patch21 -p1 -b .lib64
%endif
./make_configure
popd

pushd foomatic-db-hpijs-%{hpijsver}
popd

pushd foomatic-db-%{dbver}
%patch7 -p1 -b .ppdload-ppd

%if %{with_omni}
# Omni printers
tar xjf %{SOURCE4}
%endif

# Gimp-print-4.2.0 driver info
rm -f db/source/driver/stp.xml
pushd db/source
tar xjf %{SOURCE5}
# Fix up 'gimp-print' references to point to 'gimp-print-ijs'.
perl -pi -e 's,>gimp-print<,>gimp-print-ijs<,' printer/*.xml
popd
rm -f db/source/opt/gimp-print-printoutmode.xml
%patch9 -p1 -b .printoutmode

popd

%build
### MUST NOT USE THE %%{_smp_mflags}.
%undefine _smp_mflags
pushd foomatic-filters-%{filtersver}
%configure
make PREFIX=%{_prefix} CFLAGS="%{optflags}"
popd

pushd foomatic-db-engine-%{enginever}
%configure --disable-xmltest
make PREFIX=%{_prefix} CFLAGS="%{optflags}"
popd

pushd foomatic-db-%{dbver}
%configure
make PREFIX=%{_prefix} CFLAGS="%{optflags}"
popd

pushd foomatic-db-hpijs-%{hpijsver}
%configure
make PREFIX=%{_prefix} CFLAGS="%{optflags}"
popd

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

pushd foomatic-filters-%{filtersver}
eval `perl '-V:installsitelib' '-V:installsitearch'`
mkdir -p %{buildroot}/$installsitelib
export INSTALLSITELIB=%{buildroot}/$installsitelib
export INSTALLSITEARCH=%{buildroot}/$installsitearch
make    DESTDIR=%{buildroot} PREFIX=%{_prefix} \
        INSTALLSITELIB=%{buildroot}/$installsitelib \
        INSTALLSITEARCH=%{buildroot}/$installsitearch \
        install
popd

pushd foomatic-db-engine-%{enginever}
make    DESTDIR=%{buildroot} PREFIX=%{_prefix} \
        INSTALLSITELIB=$installsitelib \
        INSTALLSITEARCH=$installsitearch \
        install
popd

pushd foomatic-db-%{dbver}
make    DESTDIR=%{buildroot} PREFIX=%{_prefix} \
        INSTALLSITELIB=%{buildroot}/$installsitelib \
        INSTALLSITEARCH=%{buildroot}/$installsitearch \
        install

%if %with_omni
# Install printers from the Omni project, if there isn't already an entry
cd Omni-printers
P_DIR=%{buildroot}/usr/share/foomatic/db/source/printer
perl -pi -e 's/driver>omni-xml/driver>omni-compiled/' *.xml
for P in *.xml; do
       if [ ! -f $P_DIR/$P ]; then
               cp $P $P_DIR;
       fi;
done;
cd ..
%endif

popd

pushd foomatic-db-hpijs-%{hpijsver}
make    DESTDIR=%{buildroot} PREFIX=%{_prefix} \
        INSTALLSITELIB=%{buildroot}/$installsitelib \
        INSTALLSITEARCH=%{buildroot}/$installsitearch \
        install
popd

# Remove ghostscript UPP drivers that are gone in 7.07
rm -f %{buildroot}%{_datadir}/foomatic/db/source/driver/{bjc6000a1,PM760p,PM820p,s400a1,sharp,Stc670pl,Stc670p,Stc680p,Stc760p,Stc777p,Stp720p,Stp870p}.upp.xml

# Remove drivers with no command line.
pushd foomatic-db-engine-%{enginever}
PERL5LIB=%{buildroot}/$installsitelib ./foomatic-cleanupdrivers %{buildroot}%{_datadir}/foomatic
popd

# Update any old-style printer IDs still left around.
echo '#!/usr/bin/perl -pi' > convert-printerids.pl
sed -e 's|^\(.*\) \(.*\)$|s,printer/\1,printer/\2,g;|' \
        %{buildroot}%{_datadir}/foomatic/db/oldprinterids \
        >> convert-printerids.pl
chmod a+x convert-printerids.pl
./convert-printerids.pl %{buildroot}%{_datadir}/foomatic/db/source/{opt,driver}/*.xml
find %{buildroot}%{_datadir}/foomatic/db/source/ -type f | xargs chmod 0644

# Use relative, not absolute, symlink for CUPS filter.
ln -sf ../../../bin/foomatic-rip %{buildroot}%{_libdir}/cups/filter/foomatic-rip

mkdir %{buildroot}%{_datadir}/foomatic/db/source/PPD/Custom
mkdir -p %{buildroot}%{_var}/cache/foomatic

# Remove things we don't ship.
rm -rf  %{buildroot}%{_libdir}/perl5/vendor_perl \
        %{buildroot}%{_libdir}/ppr \
        %{buildroot}%{_sysconfdir}/foomatic/filter.conf.sample
find %{buildroot} -name .packlist -o -name '*.xml.*' | xargs rm -f

%post
if [ -d /var/cache/foomatic ] ; then
   /bin/rm -rf /var/cache/foomatic
fi

# Try to rebuild the printconf data
if [ -x /usr/share/printconf/util/updateconf.py ] ; then
   /usr/share/printconf/util/updateconf.py >/dev/null 2>&1
fi
if [ -x /usr/sbin/printconf-backend ] ; then
   /usr/sbin/printconf-backend --force-rebuild >/dev/null 2>&1
fi

# restart the print server if it is running now
/sbin/service lpd condrestart >/dev/null 2>&1
/sbin/service cups condrestart >/dev/null 2>&1

exit 0

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc --parents */README */USAGE */ChangeLog
%dir %{_sysconfdir}/foomatic
%config(noreplace) %{_sysconfdir}/foomatic/filter.conf
%{_bindir}/*
%{_sbindir}/*
%{_prefix}/lib*/perl5/site_perl/*/Foomatic
%{_libdir}/cups/backend/beh
%{_libdir}/cups/driver/foomatic
%{_libdir}/cups/filter/foomatic-rip
%{_datadir}/foomatic
%{_datadir}/cups/model/foomatic-db-ppds
%{_mandir}/*/*
%{_var}/cache/foomatic

%changelog
* Tue Jan  2 2007 Dai OKUYAMA <dai@ouchi.nahi.to>
- (3.0.2-9m)
- add BuildRequire: cups
- fix for initial build.

* Sun Jun 11 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.0.2-8m)
- revise %%files to avoid conflicting with cups

* Thu May 11 2006 Masanobu Sato <satoshiga@momonga-linux.org>
- (3.0.2-7m)
- add lib64 patch

* Fri May  5 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-6m)
- snapver up

* Sun Jan 15 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-5m)
- sync with fc-devel

* Mon Jun 13 2005 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (3.0.2-4m)
- rebuilt against perl-5.8.7

* Fri Apr  8 2005 kourin <kourin@rinn.ne.jp>
- (3.0.2-3m)
- add Requires: foomatic-db

* Sat Jan 15 2005 Toru Hoshina <t@momonga-linux.org>
- (3.0.2-2m)
- enable x86_64.
- correct symlink.

* Thu Nov 11 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (3.0.2-1m)
- update to 3.0.2
  security fix release. (Security Advisory CAN-2004-0801).

* Sun Aug 22 2004 Tsutomu Yasuda <tom@tom.homelinux.org>
- (3.0.1-1m)
  update to 3.0.1

* Sat Apr 10 2004 Masaru SANUKI <sanuki@momonga-linux.org>
- (3.0.1-0.1.20031121.3m)
- rebuild against for libxml2-2.6.8

* Thu Mar 18 2004 Toru Hoshina <t@momonga-linux.org>
- (3.0.1-0.1.20031121.2m)
- revised spec for enabling rpm 4.2.
- perl = 5.8.2 is toooooooo strict as well as Japanese traditional OYAJI.

* Fri Dec 19 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (3.0.1-0.1.20031121.1m)
- update to 3.0.1rc1
- do not require cups, since foomatic can also be used with LPRng,
  and LPRng conflicts with cups.

* Sun Nov 09 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.0.0-0.20031102.2m)
- rebuild against perl-5.8.2

* Sun Nov 02 2003 Kenta MURATA <muraken2@nifty.com>
- (3.0.0-0.20031102.1m)
- version up.
- MUST NOT USE THE %%{_smp_mflags}.

* Wed Oct 29 2003 Kenta MURATA <muraken2@nifty.com>
- (3.0.0-0.20030509.1m)
- pretty spec file.

* Sat Jul  5 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (3.0.0-0.20030509.1m)
- update to post-3.0.0 release (CVS version as of 2003/05/09)

* Mon Mar 24 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (3.0.0-0.1.20030310.1m)
- update to post-3.0.0beta1 (CVS version as of 2003/03/10)
- add "-l" option to foomatic-compiledb

* Sun Nov 24 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.1-0.2002040603m)
- rebuild against perl-5.8.0

* Sat Apr  6 2002 Kenta MURATA <muraken@kondara.org>
- (1.1-0.2002040602k)
- update database.
- zaoriku to Omni-printers.tar.bz2.

* Sat Apr  6 2002 Kenta MURATA <muraken@kondara.org>
- (1.1-0.2001101810k)
- remove Omni-printers.tar.bz2 and foomatic-for-omni-printer.patch.

* Thu Feb 28 2002 Shingo Akagaki <dora@kondara.org>
- (1.1-0.2001101808k)
- remove Foomatic::GrovePath module

* Wed Feb 27 2002 Kenta MURATA <muraken@kondara.org>
- (1.1-0.2001101806k)
- perl = 1:5.6.1

* Wed Feb  6 2002 Kenta MURATA <muraken@kondara.org>
- (1.1-0.2001101804k)
- add option definition file for Canon BJC-700J.

* Thu Oct 25 2001 Toru Hoshina <t@kondara.org>
- (1.1-0.2001101802k)
- merge from rawhide.

* Thu Oct 18 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20011018.1
- rolled to pull in latest information.
- added Omni printers to the printer list.

* Fri Oct 05 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20011005.1
- rolled to pull in an ia64 fix to foomatic-combo-xml.c

* Mon Oct 01 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20011001.1
- rolled to pull in foomatic fixes to foomatic-combo-xml.c

* Wed Sep 05 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010905.1
- upgraded to latest foomatic, we now have fast overview generation!
- this means that there is no prebuilt overview file.

* Tue Aug 28 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010828.1
- WOW! The latest foomatic uses Till Kamppeter's C based combo compiler.
- It is now fast enough that there is no real benifit to precompiling.
- NOTE: this forces the package to stop being noarched.

* Mon Aug 27 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010827.1
- fresh pull, maybe it fixes the build errors.

* Sat Aug 25 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010825.1
- did a fresh database pull, which contains the old japanese printers as well.
- removed japanese hack.

* Tue Aug 14 2001 Akira TAGOH <tagoh@redhat.com> 1.1-0.20010717.5
- Add Japanese printer entry.

* Mon Aug  6 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010717.4
- move the cache back to /var, sigh.

* Mon Jul 23 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010717.2
- made foomatic pre-compute its db

* Thu Jul 18 2001 Crutcher Dunnavant <crutcher@redhat.com> 1.1-0.20010717.1
- imported from mandrake.

* Tue Jul 17 2001 Till Kamppeter <till@mandrakesoft.com> 1.1-0.20010717mdk
- Added job listing/removal/manipulation and queue control to
  foomatic-printjob
- Support for printing multiple copies with PDQ

* Fri Jul 14 2001 Till Kamppeter <till@mandrakesoft.com> 1.1-0.20010714mdk
- Included the cupsomatic filter script
- When a queue is set up, default options can be set now
- Help messages of foomatic-configure and foomatic-printjob cleaned up.

* Fri Jul 13 2001 Till Kamppeter <till@mandrakesoft.com> 1.1-0.20010713mdk
- Many bugfixes in "foomatic-printjob".
- "foomatic-configure" adds the Foomatic config file directory automatically
  to the search paths of PDQ.
- Printing a help page under PDQ was broken.

* Thu Jul 12 2001 Stefan van der Eijk <stefan@eijk.nu> 1.1-0.20010712mdk
- BuildRequires:  perl-devel

* Wed Jul 11 2001 Till Kamppeter <till@mandrakesoft.com> 1.1-0.20010711mdk
- initial release.
- Deleted the obsolete drivers "stp", "cZ11", and "hpdj".
- Patch applied which flushes the memory cache regularly, otherwise
  foomatic-configure would hang when the Foomatic data of GIMP-Print is
  installed.
